#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>

static int cnt;
pthread_mutex_t mtx = PTHREAD_MUTEX_INITIALIZER;

void* thread_fun( void* data ){
    int *rank = (int *)data;
    pthread_mutex_lock( &mtx );
    printf( "Hello, I am %d and cnt = %d\n", *rank, cnt );
    cnt++;
    pthread_mutex_unlock( &mtx ); 
}

int main(){

    int i;
    pthread_t tid[2];
    int data[2];

    cnt = 0;

    for( i = 0 ; i < 2 ; i++ ) {
        data[i] = i;
        pthread_create( tid+i, NULL, (void*)thread_fun, &data[i]);
    }

    for( i = 0 ; i < 2 ; i++ ) {
        pthread_join( tid[i], NULL );
    }

    printf( "Finished, cnt = %d\n", cnt );


    return EXIT_SUCCESS;
}
